package de.ozgcloud.vorgang;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import de.ozgcloud.apilib.common.callcontext.OzgCloudCallContextProvider;
import de.ozgcloud.apilib.user.GrpcOzgCloudUserProfileService;
import de.ozgcloud.apilib.user.OzgCloudUserProfileService;
import de.ozgcloud.apilib.user.UserProfileMapper;
import de.ozgcloud.user.grpc.userprofile.UserProfileServiceGrpc.UserProfileServiceBlockingStub;
import net.devh.boot.grpc.client.inject.GrpcClient;

@Configuration
class VorgangProcessorConfiguration {

	@GrpcClient("user-manager")
	private UserProfileServiceBlockingStub userProfileServiceGrpc;

	@Bean
	OzgCloudUserProfileService ozgCloudUserProfileService(UserProfileMapper mapper, OzgCloudCallContextProvider contextProvider) {
		return new GrpcOzgCloudUserProfileService(userProfileServiceGrpc, mapper, contextProvider);
	}

}
