package de.ozgcloud.vorgang.common.userconfig;

import java.util.List;

import org.springframework.stereotype.Service;

import de.ozgcloud.user.grpc.organisationseinheit.OrganisationsEinheitServiceGrpc.OrganisationsEinheitServiceBlockingStub;
import de.ozgcloud.user.organisationseinheit.GrpcGetSupportedOrganisationsEinheitenRequest;
import de.ozgcloud.user.organisationseinheit.GrpcOrganisationsEinheit;
import de.ozgcloud.vorgang.callcontext.VorgangManagerClientCallContextAttachingInterceptor;
import net.devh.boot.grpc.client.inject.GrpcClient;

@Service
public class UserConfigRemoteService {

	@GrpcClient("user-manager")
	private OrganisationsEinheitServiceBlockingStub serviceStub;

	public List<String> getSupportedOrganisationsEinheiten() {
		return getOrganisationsEinheiten().stream().map(GrpcOrganisationsEinheit::getOrganisationsEinheitId)
				.toList();
	}

	List<GrpcOrganisationsEinheit> getOrganisationsEinheiten() {
		return getServiceStub()
				.getSupportedOrganisationsEinheiten(GrpcGetSupportedOrganisationsEinheitenRequest.newBuilder().build())
				.getOrganisationseinheitenList();
	}

	private OrganisationsEinheitServiceBlockingStub getServiceStub() {
		return serviceStub.withInterceptors(new VorgangManagerClientCallContextAttachingInterceptor());
	}
}
